package net.pingex.discordbot;

import sx.blah.discord.api.IDiscordClient;
import java.util.ArrayList;
import java.util.logging.Logger;

/**
 * Defines a basic bot module
 * @version 0.1-dev
 * @author Raphael "Pingex" NAAS
 */
public abstract class AbstractModule
{
	/**
	 * Contains all `AbstractModule` instances created.
	 */
	private static final ArrayList<AbstractModule> REGISTERED = new ArrayList<>();

	protected Logger logger;

	/**
	 * Constructor doing all the basic stuff, like registering as a Listener to Discord, getting a logger, etc.
	 * @param client Discord Client instance used to register self.
	 */
	public AbstractModule(IDiscordClient client)
	{
		REGISTERED.add(this);
		client.getDispatcher().registerListener(this);
		logger = Logger.getLogger(this.getClass().getName());
		logger.info("Loading module " + this.getClass().getName());
	}
}
