package net.pingex.discordbot;

import java.util.Hashtable;

/**
 * Implemented by modules which can be controlled using Discord Commands
 * @version 0.1-dev
 * @author Raphael "Pingex" NAAS
 */
public interface IControllable
{
	/**
	 * A list of prefixes the module uses to identify itself.
	 * @return List of prefixes
	 */
	String[] getPrefixes();

	/**
	 * Get a list of shortened commands.
	 * Example: command !module:myCommand can be shortened as !myc, !mc, or !myco, so the table would be like "myCommand" => ["myc", "mc", "myco"]
	 * @return Hastable containing all shortened commands. Key is the real command, Value is a list of eligible short commands.
	 */
	Hashtable<String, String[]> getShorthands();
}
